]> git.ipfire.org Git - thirdparty/openssl.git/blame - config
Have all relevant config targets use the env() function rather than $ENV
[thirdparty/openssl.git] / config
CommitLineData
58964a49 1#!/bin/sh
d42d0a4d 2# Copyright 1998-2017 The OpenSSL Project Authors. All Rights Reserved.
58964a49 3#
44c8a5e2
RS
4# Licensed under the OpenSSL license (the "License"). You may not use
5# this file except in compliance with the License. You can obtain a copy
6# in the file LICENSE in the source distribution or at
7# https://www.openssl.org/source/license.html
8
5d3bb220 9# OpenSSL config: determine the operating system and run ./Configure
44c8a5e2 10# Derived from minarch and GuessOS from Apache.
58964a49 11#
44c8a5e2 12# Do "config -h" for usage information.
06a2b07b 13SUFFIX=""
ffb261ff
RL
14DRYRUN="false"
15VERBOSE="false"
28a80034 16EXE=""
9fe2bb77 17THERE=`dirname $0`
06a2b07b
UM
18
19# pick up any command line args to config
20for i
21do
22case "$i" in
9e43c6b5 23-d*) options=$options" --debug";;
ffb261ff
RL
24-t*) DRYRUN="true" VERBOSE="true";;
25-v*) VERBOSE="true";;
26-h*) DRYRUN="true"; cat <<EOF
06a2b07b 27Usage: config [options]
b33c5ffe 28 -d Build with debugging when possible.
06a2b07b 29 -t Test mode, do not run the Configure perl script.
ffb261ff 30 -v Verbose mode, show the exact Configure call that is being made.
06a2b07b
UM
31 -h This help.
32
33Any other text will be passed to the Configure perl script.
34See INSTALL for instructions.
35
36EOF
37;;
38*) options=$options" $i" ;;
39esac
40done
41
58964a49
RE
42# First get uname entries that we use below
43
19a0192b
DSH
44[ "$MACHINE" ] || MACHINE=`(uname -m) 2>/dev/null` || MACHINE="unknown"
45[ "$RELEASE" ] || RELEASE=`(uname -r) 2>/dev/null` || RELEASE="unknown"
46[ "$SYSTEM" ] || SYSTEM=`(uname -s) 2>/dev/null` || SYSTEM="unknown"
47[ "$BUILD" ] || VERSION=`(uname -v) 2>/dev/null` || VERSION="unknown"
58964a49 48
8f6dc9c5 49
58964a49
RE
50# Now test for ISC and SCO, since it is has a braindamaged uname.
51#
52# We need to work around FreeBSD 1.1.5.1
53(
54XREL=`uname -X 2>/dev/null | grep "^Release" | awk '{print $3}'`
55if [ "x$XREL" != "x" ]; then
56 if [ -f /etc/kconfig ]; then
57 case "$XREL" in
58 4.0|4.1)
59 echo "${MACHINE}-whatever-isc4"; exit 0
60 ;;
61 esac
62 else
63 case "$XREL" in
64 3.2v4.2)
65 echo "whatever-whatever-sco3"; exit 0
66 ;;
67 3.2v5.0*)
68 echo "whatever-whatever-sco5"; exit 0
69 ;;
70 4.2MP)
7c4e24af 71 case "x${VERSION}" in
9abff96b
AP
72 x2.0*) echo "whatever-whatever-unixware20"; exit 0 ;;
73 x2.1*) echo "whatever-whatever-unixware21"; exit 0 ;;
74 x2*) echo "whatever-whatever-unixware2"; exit 0 ;;
7c4e24af 75 esac
58964a49
RE
76 ;;
77 4.2)
78 echo "whatever-whatever-unixware1"; exit 0
79 ;;
14cc0aaf 80 5*)
7c4e24af
AP
81 case "x${VERSION}" in
82 # We hardcode i586 in place of ${MACHINE} for the
83 # following reason. The catch is that even though Pentium
84 # is minimum requirement for platforms in question,
85 # ${MACHINE} gets always assigned to i386. Now, problem
86 # with i386 is that it makes ./config pass 386 to
87 # ./Configure, which in turn makes make generate
88 # inefficient SHA-1 (for this moment) code.
14cc0aaf 89 x[678]*) echo "i586-sco-unixware7"; exit 0 ;;
7c4e24af 90 esac
9a5a7401 91 ;;
58964a49
RE
92 esac
93 fi
94fi
95# Now we simply scan though... In most cases, the SYSTEM info is enough
96#
97case "${SYSTEM}:${RELEASE}:${VERSION}:${MACHINE}" in
98 A/UX:*)
99 echo "m68k-apple-aux3"; exit 0
100 ;;
101
76ef6ac9
AP
102 AIX:[3-9]:4:*)
103 echo "${MACHINE}-ibm-aix"; exit 0
104 ;;
105
dd558806 106 AIX:*:[5-9]:*)
76ef6ac9 107 echo "${MACHINE}-ibm-aix"; exit 0
36810177
RL
108 ;;
109
58964a49 110 AIX:*)
76ef6ac9 111 echo "${MACHINE}-ibm-aix3"; exit 0
58964a49
RE
112 ;;
113
58964a49
RE
114 HI-UX:*)
115 echo "${MACHINE}-hi-hiux"; exit 0
116 ;;
117
118 HP-UX:*)
119 HPUXVER=`echo ${RELEASE}|sed -e 's/[^.]*.[0B]*//'`
120 case "$HPUXVER" in
6d03b73e 121 1[0-9].*) # HPUX 10 and 11 targets are unified
0a4c8baf 122 echo "${MACHINE}-hp-hpux1x"; exit 0
58964a49
RE
123 ;;
124 *)
125 echo "${MACHINE}-hp-hpux"; exit 0
126 ;;
127 esac
128 ;;
129
1656ef29 130 IRIX:6.*)
da8fa72f 131 echo "mips3-sgi-irix"; exit 0
58964a49
RE
132 ;;
133
134 IRIX64:*)
da8fa72f 135 echo "mips4-sgi-irix64"; exit 0
58964a49
RE
136 ;;
137
138 Linux:[2-9].*)
139 echo "${MACHINE}-whatever-linux2"; exit 0
140 ;;
141
142 Linux:1.*)
143 echo "${MACHINE}-whatever-linux1"; exit 0
144 ;;
145
10a2975a
RL
146 GNU*)
147 echo "hurd-x86"; exit 0;
148 ;;
149
58964a49
RE
150 LynxOS:*)
151 echo "${MACHINE}-lynx-lynxos"; exit 0
152 ;;
153
a9ffce0a
BM
154 BSD/OS:4.*) # BSD/OS always says 386
155 echo "i486-whatever-bsdi4"; exit 0
0cceb1c7
BM
156 ;;
157
58964a49 158 BSD/386:*:*:*486*|BSD/OS:*:*:*:*486*)
9c789ad1
UM
159 case `/sbin/sysctl -n hw.model` in
160 Pentium*)
8050bc79 161 echo "i586-whatever-bsdi"; exit 0
9c789ad1
UM
162 ;;
163 *)
8050bc79 164 echo "i386-whatever-bsdi"; exit 0
9c789ad1
UM
165 ;;
166 esac;
58964a49
RE
167 ;;
168
169 BSD/386:*|BSD/OS:*)
170 echo "${MACHINE}-whatever-bsdi"; exit 0
171 ;;
172
afd41c9f 173 FreeBSD:*:*:*386*)
44717474
RE
174 VERS=`echo ${RELEASE} | sed -e 's/[-(].*//'`
175 MACH=`sysctl -n hw.model`
176 ARCH='whatever'
177 case ${MACH} in
178 *386* ) MACH="i386" ;;
179 *486* ) MACH="i486" ;;
180 Pentium\ II*) MACH="i686" ;;
181 Pentium* ) MACH="i586" ;;
44717474
RE
182 * ) MACH="$MACHINE" ;;
183 esac
184 case ${MACH} in
185 i[0-9]86 ) ARCH="pc" ;;
186 esac
187 echo "${MACH}-${ARCH}-freebsd${VERS}"; exit 0
188 ;;
58964a49 189
2df7f11f 190 DragonFly:*)
191 echo "${MACHINE}-whatever-dragonfly"; exit 0
192 ;;
193
afd41c9f
RL
194 FreeBSD:*)
195 echo "${MACHINE}-whatever-freebsd"; exit 0
196 ;;
197
6e08e9e7
JD
198 Haiku:*)
199 echo "${MACHINE}-whatever-haiku"; exit 0
200 ;;
201
c6fdd7dc 202 NetBSD:*:*:*386*)
48d89b56 203 echo "`(/usr/sbin/sysctl -n hw.model || /sbin/sysctl -n hw.model) | sed 's,.*\(.\)86-class.*,i\186,'`-whatever-netbsd"; exit 0
58964a49
RE
204 ;;
205
206 NetBSD:*)
207 echo "${MACHINE}-whatever-netbsd"; exit 0
208 ;;
209
210 OpenBSD:*)
211 echo "${MACHINE}-whatever-openbsd"; exit 0
212 ;;
213
6c36f7a9
LJ
214 OpenUNIX:*)
215 echo "${MACHINE}-unknown-OpenUNIX${VERSION}"; exit 0
216 ;;
217
58964a49 218 OSF1:*:*:*alpha*)
6bc847e4
RL
219 OSFMAJOR=`echo ${RELEASE}| sed -e 's/^V\([0-9]*\)\..*$/\1/'`
220 case "$OSFMAJOR" in
221 4|5)
222 echo "${MACHINE}-dec-tru64"; exit 0
223 ;;
224 1|2|3)
225 echo "${MACHINE}-dec-osf"; exit 0
226 ;;
227 *)
228 echo "${MACHINE}-dec-osf"; exit 0
229 ;;
230 esac
58964a49
RE
231 ;;
232
233 QNX:*)
6a9af68b 234 case "$RELEASE" in
36124b10
BM
235 4*)
236 echo "${MACHINE}-whatever-qnx4"
58964a49 237 ;;
6a9af68b
LJ
238 6*)
239 echo "${MACHINE}-whatever-qnx6"
240 ;;
58964a49 241 *)
36124b10 242 echo "${MACHINE}-whatever-qnx"
58964a49
RE
243 ;;
244 esac
245 exit 0
246 ;;
247
248 Paragon*:*:*:*)
249 echo "i860-intel-osf1"; exit 0
250 ;;
251
0fad6cb7
AP
252 Rhapsody:*)
253 echo "ppc-apple-rhapsody"; exit 0
254 ;;
255
9b7a552f 256 Darwin:*)
70d70a3c
RL
257 case "$MACHINE" in
258 Power*)
259 echo "ppc-apple-darwin${VERSION}"
260 ;;
3dfcb6a0
RL
261 x86_64)
262 echo "x86_64-apple-darwin${VERSION}"
263 ;;
70d70a3c 264 *)
ca640568 265 echo "i686-apple-darwin${VERSION}"
70d70a3c
RL
266 ;;
267 esac
268 exit 0
9b7a552f
RL
269 ;;
270
58964a49 271 SunOS:5.*)
7228920c 272 echo "${MACHINE}-whatever-solaris2"; exit 0
58964a49
RE
273 ;;
274
275 SunOS:*)
276 echo "${MACHINE}-sun-sunos4"; exit 0
277 ;;
278
279 UNIX_System_V:4.*:*)
280 echo "${MACHINE}-whatever-sysv4"; exit 0
281 ;;
282
28a80034
RL
283 VOS:*:*:i786)
284 echo "i386-stratus-vos"; exit 0
285 ;;
286
287 VOS:*:*:*)
288 echo "hppa1.1-stratus-vos"; exit 0
289 ;;
290
58964a49
RE
291 *:4*:R4*:m88k)
292 echo "${MACHINE}-whatever-sysv4"; exit 0
293 ;;
294
295 DYNIX/ptx:4*:*)
296 echo "${MACHINE}-whatever-sysv4"; exit 0
297 ;;
298
299 *:4.0:3.0:3[34]?? | *:4.0:3.0:3[34]??,*)
300 echo "i486-ncr-sysv4"; exit 0
301 ;;
302
303 ULTRIX:*)
304 echo "${MACHINE}-unknown-ultrix"; exit 0
305 ;;
306
9231f477
UM
307 POSIX-BC*)
308 echo "${MACHINE}-siemens-sysv4"; exit 0 # Here, $MACHINE == "BS2000"
309 ;;
310
58964a49
RE
311 machten:*)
312 echo "${MACHINE}-tenon-${SYSTEM}"; exit 0;
313 ;;
314
315 library:*)
316 echo "${MACHINE}-ncr-sysv4"; exit 0
317 ;;
318
319 ConvexOS:*:11.0:*)
320 echo "${MACHINE}-v11-${SYSTEM}"; exit 0;
321 ;;
322
41bee3e8
RL
323 # The following combinations are supported
324 # MINGW64* on x86_64 => mingw64
325 # MINGW32* on x86_64 => mingw
326 # MINGW32* on i?86 => mingw
327 #
328 # MINGW64* on i?86 isn't expected to work...
329 MINGW64*:*:*:x86_64)
330 echo "${MACHINE}-whatever-mingw64"; exit 0;
331 ;;
4848cbf1
AP
332 MINGW*)
333 echo "${MACHINE}-whatever-mingw"; exit 0;
334 ;;
d78e5298 335 CYGWIN*)
a717c110 336 echo "${MACHINE}-pc-cygwin"; exit 0
d78e5298
UM
337 ;;
338
2f6efd6a
DSH
339 vxworks*)
340 echo "${MACHINE}-whatever-vxworks"; exit 0;
341 ;;
58964a49
RE
342esac
343
344#
345# Ugg. These are all we can determine by what we know about
346# the output of uname. Be more creative:
347#
348
349# Do the Apollo stuff first. Here, we just simply assume
478b50cf 350# that the existence of the /usr/apollo directory is proof
58964a49
RE
351# enough
352if [ -d /usr/apollo ]; then
353 echo "whatever-apollo-whatever"
354 exit 0
355fi
356
357# Now NeXT
358ISNEXT=`hostinfo 2>/dev/null`
359case "$ISNEXT" in
8e9eae0f 360 *'NeXT Mach 3.3'*)
74a6c7f3
BM
361 echo "whatever-next-nextstep3.3"; exit 0
362 ;;
58964a49
RE
363 *NeXT*)
364 echo "whatever-next-nextstep"; exit 0
365 ;;
366esac
367
368# At this point we gone through all the one's
369# we know of: Punt
370
b1fe6b43 371echo "${MACHINE}-whatever-${SYSTEM}"
58964a49
RE
372exit 0
373) 2>/dev/null | (
374
375# ---------------------------------------------------------------------------
376# this is where the translation occurs into SSLeay terms
377# ---------------------------------------------------------------------------
378
7f625320 379# Only set CC if not supplied already
8b8d2dcc
AP
380if [ -z "$CROSS_COMPILE$CC" ]; then
381 GCCVER=`sh -c "gcc -dumpversion" 2>/dev/null`
7f625320 382 if [ "$GCCVER" != "" ]; then
8b8d2dcc
AP
383 # then strip off whatever prefix egcs prepends the number with...
384 # Hopefully, this will work for any future prefixes as well.
385 GCCVER=`echo $GCCVER | LC_ALL=C sed 's/^[a-zA-Z]*\-//'`
386 # Since gcc 3.1 gcc --version behaviour has changed. gcc -dumpversion
387 # does give us what we want though, so we use that. We just just the
388 # major and minor version numbers.
389 # peak single digit before and after first dot, e.g. 2.95.1 gives 29
390 GCCVER=`echo $GCCVER | sed 's/\([0-9]\)\.\([0-9]\).*/\1\2/'`
7f625320
BL
391 CC=gcc
392 else
393 CC=cc
394 fi
1656ef29 395fi
ac7b4261 396GCCVER=${GCCVER:-0}
1d4547a4
LJ
397if [ "$SYSTEM" = "HP-UX" ];then
398 # By default gcc is a ILP32 compiler (with long long == 64).
399 GCC_BITS="32"
400 if [ $GCCVER -ge 30 ]; then
401 # PA64 support only came in with gcc 3.0.x.
0a4c8baf
AP
402 # We check if the preprocessor symbol __LP64__ is defined...
403 if echo "__LP64__" | gcc -v -E -x c - 2>/dev/null | grep "^__LP64__" 2>&1 > /dev/null; then
404 : # __LP64__ has slipped through, it therefore is not defined
405 else
1d4547a4
LJ
406 GCC_BITS="64"
407 fi
408 fi
409fi
1656ef29 410if [ "$SYSTEM" = "SunOS" ]; then
ac7b4261
AP
411 if [ $GCCVER -ge 30 ]; then
412 # 64-bit ABI isn't officially supported in gcc 3.0, but it appears
413 # to be working, at the very least 'make test' passes...
414 if gcc -v -E -x c /dev/null 2>&1 | grep __arch64__ > /dev/null; then
415 GCC_ARCH="-m64"
416 else
417 GCC_ARCH="-m32"
418 fi
419 fi
bdf5e183 420 # check for WorkShop C, expected output is "cc: blah-blah C x.x"
1656ef29
AP
421 CCVER=`(cc -V 2>&1) 2>/dev/null | \
422 egrep -e '^cc: .* C [0-9]\.[0-9]' | \
423 sed 's/.* C \([0-9]\)\.\([0-9]\).*/\1\2/'`
424 CCVER=${CCVER:-0}
0abfd606 425 if [ $MACHINE != i86pc -a $CCVER -gt 40 ]; then
1656ef29
AP
426 CC=cc # overrides gcc!!!
427 if [ $CCVER -eq 50 ]; then
428 echo "WARNING! Detected WorkShop C 5.0. Do make sure you have"
429 echo " patch #107357-01 or later applied."
430 sleep 5
431 fi
744029c1 432 fi
58964a49
RE
433fi
434
726c2231 435if [ "${SYSTEM}" = "AIX" ]; then # favor vendor cc over gcc
439909a0 436 (cc) 2>&1 | grep -iv "not found" > /dev/null && CC=cc
726c2231
AP
437fi
438
da8fa72f
AP
439CCVER=${CCVER:-0}
440
58964a49
RE
441# read the output of the embedded GuessOS
442read GUESSOS
443
b1fe6b43 444echo Operating system: $GUESSOS
58964a49
RE
445
446# now map the output into SSLeay terms ... really should hack into the
447# script above so we end up with values in vars but that would take
448# more time that I want to waste at the moment
449case "$GUESSOS" in
15c7adb0
DSH
450 uClinux*64*)
451 OUT=uClinux-dist64
452 ;;
453 uClinux*)
454 OUT=uClinux-dist
455 ;;
da8fa72f 456 mips3-sgi-irix)
da8fa72f
AP
457 OUT="irix-mips3-$CC"
458 ;;
459 mips4-sgi-irix64)
460 echo "WARNING! If you wish to build 64-bit library, then you have to"
9fe2bb77 461 echo " invoke '$THERE/Configure irix64-mips4-$CC' *manually*."
ffb261ff 462 if [ "$DRYRUN" = "false" -a -t 1 ]; then
ac7b4261 463 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 464 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
06a2b07b 465 fi
da8fa72f
AP
466 OUT="irix-mips3-$CC"
467 ;;
b7efa56a 468 ppc-apple-rhapsody) OUT="rhapsody-ppc-cc" ;;
d6c76457
AP
469 ppc-apple-darwin*)
470 ISA64=`(sysctl -n hw.optional.64bitops) 2>/dev/null`
af036845 471 if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
d6c76457 472 echo "WARNING! If you wish to build 64-bit library, then you have to"
9fe2bb77 473 echo " invoke '$THERE/Configure darwin64-ppc-cc' *manually*."
ffb261ff 474 if [ "$DRYRUN" = "false" -a -t 1 ]; then
d6c76457 475 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 476 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
d6c76457
AP
477 fi
478 fi
af036845
AP
479 if [ "$ISA64" = "1" -a "$KERNEL_BITS" = "64" ]; then
480 OUT="darwin64-ppc-cc"
481 else
482 OUT="darwin-ppc-cc"
483 fi ;;
ca640568 484 i?86-apple-darwin*)
0bb01b7d 485 ISA64=`(sysctl -n hw.optional.x86_64) 2>/dev/null`
af036845 486 if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
0bb01b7d 487 echo "WARNING! If you wish to build 64-bit library, then you have to"
3dfcb6a0 488 echo " invoke 'KERNEL_BITS=64 $THERE/config $options'."
ffb261ff 489 if [ "$DRYRUN" = "false" -a -t 1 ]; then
0bb01b7d 490 echo " You have about 5 seconds to press Ctrl-C to abort."
8a4460c2 491 (trap "stty `stty -g`; exit 1" 2; stty -icanon min 0 time 50; read waste; exit 0) <&1 || exit
0bb01b7d
AP
492 fi
493 fi
af036845
AP
494 if [ "$ISA64" = "1" -a "$KERNEL_BITS" = "64" ]; then
495 OUT="darwin64-x86_64-cc"
496 else
497 OUT="darwin-i386-cc"
498 fi ;;
3dfcb6a0 499 x86_64-apple-darwin*)
3dfcb6a0
RL
500 if [ "$KERNEL_BITS" = "32" ]; then
501 OUT="darwin-i386-cc"
502 else
503 OUT="darwin64-x86_64-cc"
504 fi ;;
a2570242
AP
505 armv6+7-*-iphoneos)
506 options="$options -arch%20armv6 -arch%20armv7"
507 OUT="iphoneos-cross" ;;
508 *-*-iphoneos)
509 options="$options -arch%20${MACHINE}"
510 OUT="iphoneos-cross" ;;
b06f7d9a
AP
511 arm64-*-iphoneos|*-*-ios64)
512 OUT="ios64-cross" ;;
93cd57a5 513 alpha-*-linux2)
b7efa56a 514 ISA=`awk '/cpu model/{print$4;exit(0);}' /proc/cpuinfo`
bdf5e183 515 case ${ISA:-generic} in
b7efa56a 516 *[678]) OUT="linux-alpha+bwx-$CC" ;;
bdf5e183
AP
517 *) OUT="linux-alpha-$CC" ;;
518 esac
519 if [ "$CC" = "gcc" ]; then
520 case ${ISA:-generic} in
206a9757
DSH
521 EV5|EV45) options="$options -mcpu=ev5";;
522 EV56|PCA56) options="$options -mcpu=ev56";;
523 *) options="$options -mcpu=ev6";;
bdf5e183
AP
524 esac
525 fi
526 ;;
76ef6ac9 527 ppc64-*-linux2)
78c3e205
AP
528 if [ -z "$KERNEL_BITS" ]; then
529 echo "WARNING! If you wish to build 64-bit library, then you have to"
9fe2bb77 530 echo " invoke '$THERE/Configure linux-ppc64' *manually*."
ffb261ff 531 if [ "$DRYRUN" = "false" -a -t 1 ]; then
78c3e205 532 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 533 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
78c3e205
AP
534 fi
535 fi
536 if [ "$KERNEL_BITS" = "64" ]; then
537 OUT="linux-ppc64"
538 else
539 OUT="linux-ppc"
540 (echo "__LP64__" | gcc -E -x c - 2>/dev/null | grep "^__LP64__" 2>&1 > /dev/null) || options="$options -m32"
76ef6ac9 541 fi
76ef6ac9 542 ;;
f1982acc 543 ppc64le-*-linux2) OUT="linux-ppc64le" ;;
bdf5e183 544 ppc-*-linux2) OUT="linux-ppc" ;;
b8c59291
AP
545 mips64*-*-linux2)
546 echo "WARNING! If you wish to build 64-bit library, then you have to"
9fe2bb77 547 echo " invoke '$THERE/Configure linux64-mips64' *manually*."
ffb261ff 548 if [ "$DRYRUN" = "false" -a -t 1 ]; then
b8c59291 549 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 550 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
b8c59291
AP
551 fi
552 OUT="linux-mips64"
553 ;;
554 mips*-*-linux2) OUT="linux-mips32" ;;
2f6efd6a
DSH
555 ppc60x-*-vxworks*) OUT="vxworks-ppc60x" ;;
556 ppcgen-*-vxworks*) OUT="vxworks-ppcgen" ;;
1fb2e0f9
DSH
557 pentium-*-vxworks*) OUT="vxworks-pentium" ;;
558 simlinux-*-vxworks*) OUT="vxworks-simlinux" ;;
559 mips-*-vxworks*) OUT="vxworks-mips";;
010712ff 560 ia64-*-linux?) OUT="linux-ia64" ;;
a0618e3e 561 sparc64-*-linux2)
c14b4d6b 562 echo "WARNING! If you *know* that your GNU C supports 64-bit/V9 ABI"
6d4ac67a 563 echo " and wish to build 64-bit library, then you have to"
9fe2bb77 564 echo " invoke '$THERE/Configure linux64-sparcv9' *manually*."
ffb261ff 565 if [ "$DRYRUN" = "false" -a -t 1 ]; then
6d4ac67a 566 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 567 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
6d4ac67a 568 fi
a0618e3e 569 OUT="linux-sparcv9" ;;
da8fa72f 570 sparc-*-linux2)
b7efa56a 571 KARCH=`awk '/^type/{print$3;exit(0);}' /proc/cpuinfo`
a0618e3e
AP
572 case ${KARCH:-sun4} in
573 sun4u*) OUT="linux-sparcv9" ;;
574 sun4m) OUT="linux-sparcv8" ;;
575 sun4d) OUT="linux-sparcv8" ;;
b7efa56a 576 *) OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
a0618e3e 577 esac ;;
57a68b21
AP
578 parisc*-*-linux2)
579 # 64-bit builds under parisc64 linux are not supported and
580 # compiler is expected to generate 32-bit objects...
581 CPUARCH=`awk '/cpu family/{print substr($5,1,3); exit(0);}' /proc/cpuinfo`
582 CPUSCHEDULE=`awk '/^cpu.[ ]*: PA/{print substr($3,3); exit(0);}' /proc/cpuinfo`
95f8c719
RL
583
584 # ??TODO ?? Model transformations
585 # 0. CPU Architecture for the 1.1 processor has letter suffixes. We strip that off
586 # assuming no further arch. identification will ever be used by GCC.
587 # 1. I'm most concerned about whether is a 7300LC is closer to a 7100 versus a 7100LC.
588 # 2. The variant 64-bit processors cause concern should GCC support explicit schedulers
589 # for these chips in the future.
590 # PA7300LC -> 7100LC (1.1)
591 # PA8200 -> 8000 (2.0)
592 # PA8500 -> 8000 (2.0)
593 # PA8600 -> 8000 (2.0)
594
57a68b21 595 CPUSCHEDULE=`echo $CPUSCHEDULE|sed -e 's/7300LC/7100LC/' -e 's/8.00/8000/'`
95f8c719
RL
596 # Finish Model transformations
597
b7efa56a
AP
598 options="$options -DB_ENDIAN -mschedule=$CPUSCHEDULE -march=$CPUARCH"
599 OUT="linux-generic32" ;;
2c3ee162 600 armv[1-3]*-*-linux2) OUT="linux-generic32" ;;
87873f43 601 armv[7-9]*-*-linux2) OUT="linux-armv4"; options="$options -march=armv7-a" ;;
7722e53f 602 arm*-*-linux2) OUT="linux-armv4" ;;
e8d93e34 603 aarch64-*-linux2) OUT="linux-aarch64" ;;
02756aa8
LJ
604 sh*b-*-linux2) OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
605 sh*-*-linux2) OUT="linux-generic32"; options="$options -DL_ENDIAN" ;;
072dfb9e 606 m68k*-*-linux2) OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
b900df52 607 s390-*-linux2) OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
e822c756
AP
608 s390x-*-linux2)
609 # To be uncommented when glibc bug is fixed, see Configure...
610 #if egrep -e '^features.* highgprs' /proc/cpuinfo >/dev/null ; then
611 # echo "WARNING! If you wish to build \"highgprs\" 32-bit library, then you"
612 # echo " have to invoke './Configure linux32-s390x' *manually*."
ffb261ff 613 # if [ "$DRYRUN" = "false" -a -t -1 ]; then
e822c756 614 # echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 615 # (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
e822c756
AP
616 # fi
617 #fi
618 OUT="linux64-s390x"
619 ;;
c5c0cac5
AP
620 x86_64-*-linux?)
621 if $CC -dM -E -x c /dev/null 2>&1 | grep -q ILP32 > /dev/null; then
622 OUT="linux-x32"
623 else
624 OUT="linux-x86_64"
625 fi ;;
27a451e3
RL
626 *86-*-linux2)
627 # On machines where the compiler understands -m32, prefer a
628 # config target that uses it
629 if $CC -m32 -E -x c /dev/null > /dev/null 2>&1; then
630 OUT="linux-x86"
631 else
632 OUT="linux-elf"
633 fi ;;
8f3bc096
AP
634 *86-*-linux1) OUT="linux-aout" ;;
635 *-*-linux?) OUT="linux-generic32" ;;
160065c5 636 sun4[uv]*-*-solaris2)
cc8aa08b 637 OUT="solaris-sparcv9-$CC"
74c2db31 638 ISA64=`(isainfo) 2>/dev/null | grep sparcv9`
bba391a9 639 if [ "$ISA64" != "" -a "$KERNEL_BITS" = "" ]; then
ac7b4261 640 if [ "$CC" = "cc" -a $CCVER -ge 50 ]; then
1656ef29 641 echo "WARNING! If you wish to build 64-bit library, then you have to"
9fe2bb77 642 echo " invoke '$THERE/Configure solaris64-sparcv9-cc' *manually*."
ffb261ff 643 if [ "$DRYRUN" = "false" -a -t 1 ]; then
ac7b4261 644 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 645 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
06a2b07b 646 fi
ac7b4261
AP
647 elif [ "$CC" = "gcc" -a "$GCC_ARCH" = "-m64" ]; then
648 # $GCC_ARCH denotes default ABI chosen by compiler driver
649 # (first one found on the $PATH). I assume that user
650 # expects certain consistency with the rest of his builds
651 # and therefore switch over to 64-bit. <appro>
652 OUT="solaris64-sparcv9-gcc"
653 echo "WARNING! If you wish to build 32-bit library, then you have to"
9fe2bb77 654 echo " invoke '$THERE/Configure solaris-sparcv9-gcc' *manually*."
ffb261ff 655 if [ "$DRYRUN" = "false" -a -t 1 ]; then
ac7b4261 656 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 657 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
ac7b4261
AP
658 fi
659 elif [ "$GCC_ARCH" = "-m32" ]; then
660 echo "NOTICE! If you *know* that your GNU C supports 64-bit/V9 ABI"
661 echo " and wish to build 64-bit library, then you have to"
9fe2bb77 662 echo " invoke '$THERE/Configure solaris64-sparcv9-gcc' *manually*."
ffb261ff 663 if [ "$DRYRUN" = "false" -a -t 1 ]; then
ac7b4261 664 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 665 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
ac7b4261
AP
666 fi
667 fi
1656ef29 668 fi
bba391a9
AP
669 if [ "$ISA64" != "" -a "$KERNEL_BITS" = "64" ]; then
670 OUT="solaris64-sparcv9-$CC"
671 fi
ac7b4261 672 ;;
7228920c
BM
673 sun4m-*-solaris2) OUT="solaris-sparcv8-$CC" ;;
674 sun4d-*-solaris2) OUT="solaris-sparcv8-$CC" ;;
675 sun4*-*-solaris2) OUT="solaris-sparcv7-$CC" ;;
0abfd606 676 *86*-*-solaris2)
74c2db31 677 ISA64=`(isainfo) 2>/dev/null | grep amd64`
bba391a9 678 if [ "$ISA64" != "" -a ${KERNEL_BITS:-64} -eq 64 ]; then
0abfd606
AP
679 OUT="solaris64-x86_64-$CC"
680 else
681 OUT="solaris-x86-$CC"
e4c9b85e
AP
682 if [ `uname -r | sed -e 's/5\.//'` -lt 10 ]; then
683 options="$options no-sse2"
684 fi
0abfd606
AP
685 fi
686 ;;
b7efa56a
AP
687 *-*-sunos4) OUT="sunos-$CC" ;;
688
b2d91a69 689 *86*-*-bsdi4) OUT="BSD-x86-elf"; options="$options no-sse2 -ldl" ;;
e45c1007
AP
690 alpha*-*-*bsd*) OUT="BSD-generic64"; options="$options -DL_ENDIAN" ;;
691 powerpc64-*-*bsd*) OUT="BSD-generic64"; options="$options -DB_ENDIAN" ;;
b7efa56a
AP
692 sparc64-*-*bsd*) OUT="BSD-sparc64" ;;
693 ia64-*-*bsd*) OUT="BSD-ia64" ;;
2df7f11f 694 x86_64-*-dragonfly*) OUT="BSD-x86_64" ;;
b7efa56a 695 amd64-*-*bsd*) OUT="BSD-x86_64" ;;
8b452002
AP
696 *86*-*-*bsd*) # mimic ld behaviour when it's looking for libc...
697 if [ -L /usr/lib/libc.so ]; then # [Free|Net]BSD
698 libc=/usr/lib/libc.so
699 else # OpenBSD
700 # ld searches for highest libc.so.* and so do we
c256e69d 701 libc=`(ls /usr/lib/libc.so.* /lib/libc.so.* | tail -1) 2>/dev/null`
8b452002
AP
702 fi
703 case "`(file -L $libc) 2>/dev/null`" in
e1892f23 704 *ELF*) OUT="BSD-x86-elf" ;;
e4c9b85e 705 *) OUT="BSD-x86"; options="$options no-sse2" ;;
e1892f23 706 esac ;;
8f3bc096
AP
707 *-*-*bsd*) OUT="BSD-generic32" ;;
708
6e08e9e7
JD
709 x86_64-*-haiku) OUT="haiku-x86_64" ;;
710 *-*-haiku) OUT="haiku-x86" ;;
b7efa56a
AP
711
712 *-*-osf) OUT="osf1-alpha-cc" ;;
713 *-*-tru64) OUT="tru64-alpha-cc" ;;
14cc0aaf 714 *-*-[Uu]nix[Ww]are7)
cb42ce0b 715 if [ "$CC" = "gcc" ]; then
14cc0aaf 716 OUT="unixware-7-gcc" ; options="$options no-sse2"
cb42ce0b 717 else
14cc0aaf 718 OUT="unixware-7" ; options="$options no-sse2 -D__i386__"
cb42ce0b
LJ
719 fi
720 ;;
5b737a07
AP
721 *-*-[Uu]nix[Ww]are20*) OUT="unixware-2.0"; options="$options no-sse2 no-sha512" ;;
722 *-*-[Uu]nix[Ww]are21*) OUT="unixware-2.1"; options="$options no-sse2 no-sha512" ;;
28a80034
RL
723 *-*-vos)
724 options="$options no-threads no-shared no-asm no-dso"
725 EXE=".pm"
726 OUT="vos-$CC" ;;
9231f477 727 BS2000-siemens-sysv4) OUT="BS2000-OSD" ;;
6d03b73e 728 *-hpux1*)
12470927
AP
729 if [ $CC = "gcc" -a $GCC_BITS = "64" ]; then
730 OUT="hpux64-parisc2-gcc"
1d4547a4 731 fi
9fa8f3a6 732 [ "$KERNEL_BITS" ] || KERNEL_BITS=`(getconf KERNEL_BITS) 2>/dev/null`
6d03b73e
AP
733 KERNEL_BITS=${KERNEL_BITS:-32}
734 CPU_VERSION=`(getconf CPU_VERSION) 2>/dev/null`
735 CPU_VERSION=${CPU_VERSION:-0}
736 # See <sys/unistd.h> for further info on CPU_VERSION.
737 if [ $CPU_VERSION -ge 768 ]; then # IA-64 CPU
bdd45497
DSH
738 if [ $KERNEL_BITS -eq 64 -a "$CC" = "cc" ]; then
739 OUT="hpux64-ia64-cc"
740 else
741 OUT="hpux-ia64-cc"
742 fi
6d03b73e 743 elif [ $CPU_VERSION -ge 532 ]; then # PA-RISC 2.x CPU
12470927 744 OUT=${OUT:-"hpux-parisc2-${CC}"}
6d03b73e
AP
745 if [ $KERNEL_BITS -eq 64 -a "$CC" = "cc" ]; then
746 echo "WARNING! If you wish to build 64-bit library then you have to"
9fe2bb77 747 echo " invoke '$THERE/Configure hpux64-parisc2-cc' *manually*."
ffb261ff 748 if [ "$DRYRUN" = "false" -a -t 1 ]; then
6d03b73e 749 echo " You have about 5 seconds to press Ctrl-C to abort."
a87c159f 750 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
6d03b73e
AP
751 fi
752 fi
74acf1c4
AP
753 # PA-RISC 2.0 is no longer supported as separate 32-bit
754 # target. This is compensated for by run-time detection
755 # in most critical assembly modules and taking advantage
d8292af4 756 # of 2.0 architecture in PA-RISC 1.1 build.
74acf1c4 757 OUT="hpux-parisc1_1-${CC}"
6d03b73e 758 elif [ $CPU_VERSION -ge 528 ]; then # PA-RISC 1.1+ CPU
74acf1c4 759 OUT="hpux-parisc1_1-${CC}"
6d03b73e 760 elif [ $CPU_VERSION -ge 523 ]; then # PA-RISC 1.0 CPU
83ed4914 761 OUT="hpux-parisc-${CC}"
6d03b73e
AP
762 else # Motorola(?) CPU
763 OUT="hpux-$CC"
764 fi
765 options="$options -D_REENTRANT" ;;
bcba6cc6 766 *-hpux) OUT="hpux-parisc-$CC" ;;
76ef6ac9 767 *-aix)
9fa8f3a6 768 [ "$KERNEL_BITS" ] || KERNEL_BITS=`(getconf KERNEL_BITMODE) 2>/dev/null`
dd558806 769 KERNEL_BITS=${KERNEL_BITS:-32}
76ef6ac9 770 OBJECT_MODE=${OBJECT_MODE:-32}
dd558806
AP
771 if [ "$CC" = "gcc" ]; then
772 OUT="aix-gcc"
a0e4a8e1
DSH
773 if [ $OBJECT_MODE -eq 64 ]; then
774 echo 'Your $OBJECT_MODE was found to be set to 64'
775 OUT="aix64-gcc"
776 fi
76ef6ac9
AP
777 elif [ $OBJECT_MODE -eq 64 ]; then
778 echo 'Your $OBJECT_MODE was found to be set to 64'
779 OUT="aix64-cc"
dd558806 780 else
76ef6ac9
AP
781 OUT="aix-cc"
782 if [ $KERNEL_BITS -eq 64 ]; then
783 echo "WARNING! If you wish to build 64-bit kit, then you have to"
9fe2bb77 784 echo " invoke '$THERE/Configure aix64-cc' *manually*."
ffb261ff 785 if [ "$DRYRUN" = "false" -a -t 1 ]; then
76ef6ac9 786 echo " You have ~5 seconds to press Ctrl-C to abort."
a87c159f 787 (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
76ef6ac9
AP
788 fi
789 fi
dd558806 790 fi
0a29f511 791 if (lsattr -E -O -l `lsdev -c processor|awk '{print$1;exit}'` | grep -i powerpc) >/dev/null 2>&1; then
60dd0857
AP
792 : # this applies even to Power3 and later, as they return PowerPC_POWER[345]
793 else
794 options="$options no-asm"
795 fi
dd558806 796 ;;
58964a49 797 # these are all covered by the catchall below
3f542969 798 i[3456]86-*-cygwin) OUT="Cygwin-x86" ;;
a717c110 799 *-*-cygwin) OUT="Cygwin-${MACHINE}" ;;
4f33534c
DSH
800 x86pc-*-qnx6) OUT="QNX6-i386" ;;
801 *-*-qnx6) OUT="QNX6" ;;
8fcdb1e6 802 x86-*-android|i?86-*-android) OUT="android-x86" ;;
893fe73a
RL
803 armv[7-9]*-*-android)
804 OUT="android-armeabi"; options="$options -march=armv7-a" ;;
805 arm*-*-android) OUT="android-armeabi" ;;
58964a49 806 *) OUT=`echo $GUESSOS | awk -F- '{print $3}'`;;
5d3bb220
UM
807esac
808
478b50cf 809# NB: This atalla support has been superseded by the ENGINE support
5270e702
RL
810# That contains its own header and definitions anyway. Support can
811# be enabled or disabled on any supported platform without external
812# headers, eg. by adding the "hw-atalla" switch to ./config or
813# perl Configure
814#
bd03b99b 815# See whether we can compile Atalla support
5270e702
RL
816#if [ -f /usr/include/atasi.h ]
817#then
818# options="$options -DATALLA"
819#fi
bd03b99b 820
1fb2e0f9
DSH
821if [ -n "$CONFIG_OPTIONS" ]; then
822 options="$options $CONFIG_OPTIONS"
823fi
824
8b8d2dcc
AP
825if expr "$options" : '.*no\-asm' > /dev/null; then :; else
826 sh -c "$CROSS_COMPILE${CC:-gcc} -Wa,--help -c -o /tmp/null.$$.o -x assembler /dev/null && rm /tmp/null.$$.o" 2>&1 | \
827 grep \\--noexecstack >/dev/null && \
2966c2ec 828 options="$options -Wa,--noexecstack"
1fb2e0f9 829fi
2966c2ec 830
9540ccdf 831# gcc < 2.8 does not support -march=ultrasparc
1656ef29 832if [ "$OUT" = solaris-sparcv9-gcc -a $GCCVER -lt 28 ]
b6735832 833then
d0590fe6
AP
834 echo "WARNING! Falling down to 'solaris-sparcv8-gcc'."
835 echo " Upgrade to gcc-2.8 or later."
1656ef29 836 sleep 5
d0590fe6 837 OUT=solaris-sparcv8-gcc
a0618e3e
AP
838fi
839if [ "$OUT" = "linux-sparcv9" -a $GCCVER -lt 28 ]
840then
841 echo "WARNING! Falling down to 'linux-sparcv8'."
842 echo " Upgrade to gcc-2.8 or later."
1656ef29 843 sleep 5
a0618e3e 844 OUT=linux-sparcv8
b6735832
UM
845fi
846
5d3bb220
UM
847case "$GUESSOS" in
848 i386-*) options="$options 386" ;;
58964a49
RE
849esac
850
a0c3e4fa 851for i in aes aria bf camellia cast des dh dsa ec hmac idea md2 md5 mdc2 rc2 rc4 rc5 ripemd rsa seed sha sm3 sm4
9231f477 852do
9fe2bb77 853 if [ ! -d $THERE/crypto/$i ]
9231f477
UM
854 then
855 options="$options no-$i"
856 fi
857done
858
58964a49
RE
859if [ -z "$OUT" ]; then
860 OUT="$CC"
861fi
862
99aab161
UM
863if [ ".$PERL" = . ] ; then
864 for i in . `echo $PATH | sed 's/:/ /g'`; do
28a80034
RL
865 if [ -f "$i/perl5$EXE" ] ; then
866 PERL="$i/perl5$EXE"
99aab161
UM
867 break;
868 fi;
869 done
870fi
871
872if [ ".$PERL" = . ] ; then
873 for i in . `echo $PATH | sed 's/:/ /g'`; do
28a80034
RL
874 if [ -f "$i/perl$EXE" ] ; then
875 if "$i/perl$EXE" -e 'exit($]<5.0)'; then
876 PERL="$i/perl$EXE"
a5a47e4a
UM
877 break;
878 fi;
99aab161
UM
879 fi;
880 done
881fi
882
a5a47e4a 883if [ ".$PERL" = . ] ; then
99aab161
UM
884 echo "You need Perl 5."
885 exit 1
886fi
887
58964a49
RE
888# run Configure to check to see if we need to specify the
889# compiler for the platform ... in which case we add it on
890# the end ... otherwise we leave it off
99aab161 891
9fe2bb77 892$PERL $THERE/Configure LIST | grep "$OUT-$CC" > /dev/null
58964a49
RE
893if [ $? = "0" ]; then
894 OUT="$OUT-$CC"
895fi
896
d2a5c40d 897OUT="$OUT"
58964a49 898
9fe2bb77 899$PERL $THERE/Configure LIST | grep "$OUT" > /dev/null
b1fe6b43 900if [ $? = "0" ]; then
ffb261ff 901 if [ "$VERBOSE" = "true" ]; then
9fe2bb77 902 echo $PERL $THERE/Configure $OUT $options
ffb261ff
RL
903 fi
904 if [ "$DRYRUN" = "false" ]; then
9fe2bb77 905 $PERL $THERE/Configure $OUT $options
b1fe6b43 906 fi
58964a49 907else
744029c1 908 echo "This system ($OUT) is not supported. See file INSTALL for details."
141d7325 909 exit 1
58964a49 910fi
26967dc3
BL
911
912if [ "$OUT" = "darwin64-x86_64-cc" ]; then
913 echo "WARNING! If you wish to build 32-bit libraries, then you have to"
914 echo " invoke 'KERNEL_BITS=32 $THERE/config $options'."
915fi
58964a49 916)